import { Dict } from 'tslang';
export interface IAdapter<TOptions = AdapterRunScriptArgumentOptions> {
    readonly type: string;
    runScript(argument: AdapterRunScriptArgument<TOptions>): Promise<AdapterRunScriptResult>;
}
export interface AdapterRunScriptArgument<TOptions = AdapterRunScriptArgumentOptions> {
    source: string;
    resourcesPath: string;
    resourcesBaseURL: string;
    parameters: AdapterRunScriptArgumentParameters;
    options: TOptions;
    onOutput(output: string): void;
    onError(error: string): void;
}
export declare type AdapterRunScriptArgumentParameters = Dict<unknown>;
export declare type AdapterRunScriptArgumentOptions = Dict<unknown>;
export interface AdapterRunScriptResult {
    result: AdapterRunScriptResultType;
    message: string;
}
export declare type AdapterRunScriptResultType = 'done' | 'options-error' | 'parameters-error' | 'unknown-error';
